/*
  AREF_AND_RESET -- Use the AREF and RESET pins on the Arduino Nano Every
  as GPIO pins. IMPORTANT NOTE THAT the appropriate entry in the boards.txt file for
  this board must be changed from:
       nona4809.bootloader.SYSCFG0=0xC9
  to
       nona4809.bootloader.SYSCFG0=0xC1
  to disable the reset function on the RESET pin

  Copyright (C) 2020  Thomas Almy

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

  Contact the author at tom@almy.us */
#include <Pins.h>
void setup() {
  Serial.begin(9600);
  delay(900);
  ddr.aref_pin = 1; // AREF is output pin
  // RESET is input pin, connected to reset button.
}

void loop() {
  Serial.print("Reset pin value: ");
  Serial.println(pin.reset_pin);
  Serial.print("Aref pin value: ");
  Serial.println(pin.aref_pin);
  pin.aref_pin = 1; // toggle aref pin
  delay(500); // wait a bit
}
