#ifndef __TIMERS_H__
#define __TIMERS_H__
#ifdef BETTER_OPERATION
#if F_CPU == 20000000L // 20 MHz
#define TIME_TRACKING_TIMER_PERIOD    9999  // To get exactly 1ms with the /2 prescaler
#else // 16 MHz
#define TIME_TRACKING_TIMER_PERIOD    7999  // To get exactly 1ms with the /2 prescaler
#endif
#define TIME_TRACKING_TICKS_PER_OVF   (TIME_TRACKING_TIMER_PERIOD + 1)  // Timer ticks per overflow of TCB3
#define TIME_TRACKING_TIMER_DIVIDER    2    // Clock divider for TCB3
#define TIME_TRACKING_CYCLES_PER_OVF  (TIME_TRACKING_TICKS_PER_OVF * TIME_TRACKING_TIMER_DIVIDER)
#else
#define TIME_TRACKING_TIMER_PERIOD    0xFF
#define TIME_TRACKING_TICKS_PER_OVF   (TIME_TRACKING_TIMER_PERIOD + 1)  // Timer ticks per overflow of TCB3
#define TIME_TRACKING_TIMER_DIVIDER   64    // Clock divider for TCB0
#define TIME_TRACKING_CYCLES_PER_OVF  (TIME_TRACKING_TICKS_PER_OVF * TIME_TRACKING_TIMER_DIVIDER)
#endif
#define PWM_TIMER_PERIOD   0xFF  // For frequency
#define PWM_TIMER_COMPARE  0x80  // For duty cycle

#endif