/* CCL2 -- Configurable Custom Logic demo.
  LUT0 and LUT1 are used to divide the clock by two and output
  it on board pin A5. The output is turned on and off once per
  second with by disabling the sequencer using PC3.
  Copyright (C) 2020  Thomas Almy

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

  Contact the author at tom@almy.us */

void setup() {
  CCL.LUT0CTRLB = CCL_INSEL0_FEEDBACK_gc; // Input from sequencer
  CCL.TRUTH0 = 1; // Invert the input
  CCL.SEQCTRL0 = CCL_SEQSEL0_DFF_gc; // D flipflop
  // The following line configures using the 32.768kHz clock, OUTEN and ENABLE
  CCL.LUT0CTRLA = CCL_OUTEN_bm | CCL_ENABLE_bm | CCL_CLKSRC_OSCULP32K_gc;
  // The following line configures using the system clock, OUTEN, and ENABLE
  CCL.LUT0CTRLA = CCL_OUTEN_bm | CCL_ENABLE_bm;
  CCL.LUT1CTRLB = CCL_INSEL0_IO_gc; // from I/O pin
  VPORTC.DIR |= 1; // PC0 will control the D input
  CCL.TRUTH1 = 0x2; // Pass through the input
  CCL.LUT1CTRLA = CCL_ENABLE_bm; // Just turn it on
  CCL.CTRLA = 1; // Enable the CCL
}

void loop() {
  VPORTC.OUT |= 1; // Turn divider on
  delay(1);
  VPORTC.OUT &= ~1; // Turn divider off
  delay(1);
}
