/* SLEEP -- Blink the LED using the PIT, and sleep the
    rest of the time. Toggle digital pin 2 when running
    to show it is actually sleeping.
  Blinky_1 -- Blink the LED as long as the push button is depressed
  Copyright (C) 2020  Thomas Almy

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

  Contact the author at tom@almy.us */
#include <Pins.h>
#include <avr/sleep.h>
void setup() {
  RTC.CTRLA |= 0x80; // Allow running in standby sleep mode
  RTC.PITINTCTRL = 1; // Enable PI interrupt
  RTC.PITCTRLA = RTC_PERIOD_CYC16384_gc + 1; // This will be half a second. Enable PIT
  ddr.digital_2 = 1;
  ddr.digital_13 = 1;
  TCA0.SINGLE.CTRLA = 0; // Shuts off the Timer/Counters
}

void loop() {
  pin.digital_2 = 1;
  sleep_mode();
}

ISR(RTC_PIT_vect) {
  pin.digital_13 = 1; // Toggle LED
  RTC.PITINTFLAGS = 1; // clear interrupt
}
