/*
  SLOW_CLOCK -- run at 1MHz. Show how timing values have to be
  adjusted 16 times higher for devices to run at same speed.
  Copyright (C) 2020  Thomas Almy

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

  Contact the author at tom@almy.us */
#include <Pins.h>

void setup() {
  // Run at 1 MHz.
  CPU_CCP = 0xd8;
  CLKCTRL.MCLKCTRLB = (3 << 1) | 1; // Divide by 16, enabled
  Serial.begin(9600); // Doesn't set up data rate correctly
  USART3.BAUD = (4 * 1000000L) / 9600; // set the right value
  delay(800 / 16);
  ddr.digital_13 = 1; // LED is on this pin
  Serial.println("LED flashes once per second");
}

void loop() {
  Serial.print("*");
  pin.digital_13 = 1; // Toggle LED
  delay(500 / 15); // half a second delay
}
