/* SPI DRIVER -- "Generic" Arduino code to provde an SPI master for the SPI slave examples.
    Only the Arduino library is used for maximum portability
  Copyright (C) 2020  Thomas Almy

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

  Contact the author at tom@almy.us */
#include <SPI.h>
#include<Pins.h>
//For a Uno, MOSI is on 11, MISO is on 12, SCK is on 13, and we will use 2 for SS.
#define SSB (2)
void setup() {
  Serial.begin(9600);
  // put your setup code here, to run once:
  pinMode(SSB, OUTPUT);
  digitalWrite(SSB, 1);
  SPI.begin();
  SPI.beginTransaction(SPISettings(1000000, LSBFIRST, SPI_MODE0));

}

uint8_t masterOutData[4] = {0x55, 0xaa, 0x21, 0x31};
uint8_t masterInData[4] = {0, 0, 0, 0};

void loop() {
  uint8_t i;
  digitalWrite(SSB, 0);
  for (i = 0; i < 4; i++) {
    masterInData[i] = SPI.transfer(masterOutData[i]);
    //    delay(1); // A delay is needed for the unbuffered slave version
  }
  digitalWrite(SSB, 1);
  Serial.print("Received:");
  for ( i = 0; i < 4; i++) {
    Serial.print(" ");
    Serial.print(masterInData[i], HEX);
  }
  Serial.println("");
  delay(500);

}
