/* Timer/Counter A NORMAL Mode. All it does is cause a periodic interupt
 *  Using 16MHz clock for comparason with Uno/Nano
 Copyright (C) 2020  Thomas Almy

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

Contact the author at tom@almy.us */

#include <Pins.h>
void setup() {
  ddr.digital_2 = 1; // OVF toggles this
  // Using "default /64 clock divisor, 4us T/C clock period
  TCA0.SINGLE.PERBUF = 24; // Sets OVF period to 25 * 4us, 100us
                           // Will give a 5kHz frequency square wave
  TCA0.SINGLE.INTCTRL = 0x1; // OVF
  TCA0.SINGLE.CTRLB = TCA_SINGLE_WGMODE_NORMAL_gc; // Enable NORMAL mode   
}

void loop() {
  // put your main code here, to run repeatedly:
}

ISR(TCA0_OVF_vect) {
  pin.digital_2 = 1; // toggle pin
  TCA0.SINGLE.INTFLAGS = 1; // reset flag
}
