/* TCB_INT Periodic Interrupt Mode
  Copyright (C) 2020  Thomas Almy

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

  Contact the author at tom@almy.us */

#include <Pins.h>
void setup() {
  ddr.digital_2 = 1; // See interrupt on digital pin 2
  EVSYS.CHANNEL0 = EVSYS_GENERATOR_TCB0_CMP0_gc; // Route output
  EVSYS.USEREVOUTB = EVSYS_CHANNEL_CHANNEL0_gc; // to digital 5
  ddr.digital_5 = 1;
  TCB0.CTRLA = 0; // Turn off channel for configuring
  TCB0.CTRLB = 0x0; // Periodic Interrupt Mode
  TCB0.CCMP = 159; // 160 clocks per period, 10us
  TCB0.INTCTRL = 1; // Enable interrupts
  TCB0.CTRLA = 1; // Enable and use system clock
}

void loop() {

}

ISR(TCB0_INT_vect) {
  pin.digital_2 = 1; // toggle pin
  TCB0.INTFLAGS = 1; // Clear the interrupt
}
