/* TCB_TIMEOUT -- TCB Time-Out Check Mode
    Copyright (C) 2020  Thomas Almy

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

  Contact the author at tom@almy.us */

#include <Pins.h>
void setup() {
  Serial.begin(9600);
  analogWrite(3, 64); // 256us high, 768us low
  EVSYS.CHANNEL4 = EVSYS_GENERATOR_PORT1_PIN5_gc; // Route pin 3, PF5
  EVSYS.USERTCB0 = EVSYS_CHANNEL_CHANNEL4_gc; // to TCB0
  TCB0.CTRLA = 0; // Turn off channel for configuring
  TCB0.CTRLB = 0x1; // time-out check mode
  TCB0.CCMP = 500*16; // Time out at 500us
//  TCB0.EVCTRL = 0x41; // Enable input capture, positive pulse
  TCB0.EVCTRL = 0x51; // Enable input capture, negative pulse
  TCB0.INTCTRL = 1; // Enable interrupt
  TCB0.CTRLA = 1; // Enable and use system clock
}

volatile bool timeOut;

void loop() {
  bool tempVal;
  delay(1000);
  tempVal = timeOut;
  if (tempVal) {
    Serial.println("Time out");
  } else {
    Serial.println("No Time out");
  }
}

ISR(TCB0_INT_vect) {
  timeOut = true; 
  TCB0.INTFLAGS = 1; // clear interrupt flag
}
