/*
  adc_2 --  Continously read A2 and report value ten times a second.
  Doesn't use interrupts.
  Copyright (C) 2020  Thomas Almy

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

  Contact the author at tom@almy.us */


void setup() {
  Serial.begin(9600);
  VREF.CTRLA = VREF_ADC0REFSEL_4V34_gc; // 4.34 volt reference
  PORTD.PIN1CTRL = PORT_ISC_INPUT_DISABLE_gc; // Disable digital on A2 (Pin PD1)
  ADC0.CTRLA = ADC_FREERUN_bm + ADC_ENABLE_bm; // Enable the ADC in free run mode
  ADC0.CTRLB = 3; // 8 samples per measurement (2^3)
  ADC0.CTRLC = ADC_SAMPCAP_bm + 3; // VDD reference, correct clock divisor (16)
  ADC0.MUXPOS = ADC_MUXPOS_AIN1_gc; // This is input from pin A2
  ADC0.COMMAND = 1; // Start the conversion
  delay(700);
}

void loop() {
  // Scaling takes into account 4.34 volt reference and the 8 samples
  Serial.println(ADC0.RES * 4340L / (1024 * 8));
  delay(100);
}
