/*
  interrupt_test -- shows operation of port pin interrupts and digital I/O.
  Copyright (C) 2020  Thomas Almy

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

  Contact the author at tom@almy.us */

#include <Pins.h>

void setup() {
  analogWrite(3, 128); // Put a square wave on pin 3, PF05
  ddr.digital_4 = 1; // Set pins 4 and 5 as outputs.
  ddr.digital_5 = 1;
  PORTF.PIN5CTRL |= PORT_ISC_BOTHEDGES_gc; // interrupt on both edges of PF5
  EVSYS.CHANNEL0 = EVSYS_GENERATOR_TCB1_CMP0_gc; // PWM event is output
  EVSYS.USEREVOUTA = EVSYS_CHANNEL_CHANNEL0_gc; // on Arduino pin A4
  EVSYS.CHANNEL4 = EVSYS_GENERATOR_PORT1_PIN5_gc; // Read digital pin 4
  EVSYS.USEREVOUTD = EVSYS_CHANNEL_CHANNEL4_gc;  // on Arduino pin A1
}

ISR(PORTF_PORT_vect) {
  if (VPORTF.INTFLAGS & ( 1 << 5)) { // or intflg.digital_3
    if (pin.digital_3 != 0) {
      pin.digital_4 = 1; // toggle pin 4
      port.digital_5 = 0; // lower pin 5
    } else {
      port.digital_5 = 1; // raise pin 5
    }
    //    VPORTF.INTFLAGS |= (1 << 5); // clear the flag or
    intflg.digital_3 = 1; // this way is the same
  }
}

void loop() {
  // put your main code here, to run repeatedly:

}
